from Envs import BaseEnv
from Trainers import Base_trainer
import argparse
import torch
import os
parser = argparse.ArgumentParser()
parser.add_argument('--buffer_memory', type=int, default=100)
parser.add_argument('--prior',  type=int, default=70)
parser.add_argument('--batch_size', type=int, default=60)
parser.add_argument('--train_epoch', type=int, default=200)
parser.add_argument('--train_mode', type=str, default="3")
parser.add_argument('--train_times', type=int, default=20)
parser.add_argument('--test_epoch', type=int, default=300)
parser.add_argument('--train_time_step', type=int, default=100)
args = parser.parse_args()

def train(env, n_batch, mem_cap, prior, epoch, T, mode, times=1):
    print("start training!")
    rewards = torch.zeros(epoch)
    rates = torch.zeros(epoch)
    model_path = "Outputs/model_" + mode + ".pth"
    data_path = "Outputs/train_data_" + mode + "_" + str(times) + ".pth"
    order = None
    if mode == "3":
        order = 3
    elif mode == "4":
        order = 4
    for time in range(times):
        print("time:", time)
        trainer = Base_trainer(n_batch=n_batch, mem_cap=mem_cap, prior=prior, order=order)
        for e in range(epoch):
            if e % 100 == 0:
                print("epoch:", e)
            s = env.reset(order)
            R = 0
            for t in range(T):
                eps = torch.rand(1)
                if eps < 0.15:
                    a_idx = torch.multinomial(torch.ones(3)/3, 1).squeeze()
                    a = trainer.decode_a_idx(a_idx, env.order)
                else:
                    a = trainer.get_a(s, env.order)
                r, s_, done, rate = env.step(a)
                R += r
                trainer.buffer.append(s, a, r, s_)
                trainer.update(env.order)
                if done or t>20:
                    break
                s = s_
            # print("R=", R)
            # print("rate=", rate)
            rewards[e] = time * rewards[e] / (time + 1) + R / (time + 1)
            rates[e] = time * rates[e] / (time + 1) + rate / (time + 1)
    torch.save(trainer.on_Q, model_path)
    torch.save((rewards, rates), data_path)


def test(env, epoch, T, executer, mode):
    print("start testing! mode:", mode)
    rewards = torch.zeros(epoch)
    rates = torch.zeros(epoch)
    data_path = "Outputs/test_data" + "_" + executer.name + "_test_" + mode + ".pth"
    for e in range(epoch):
        order = None
        if mode == "3":
            order = 3
        elif mode == "4":
            order = 4
        elif mode =="random":
            eps = torch.rand(1)
            if eps < 0.5:
                order = 3
            else:
                order = 4
        s = env.reset(order)
        R = 0
        rate = None
        for t in range(T):
            a = executer.get_a(s, env.order)
            # print("a=", a)
            r, s_, done, rate = env.step(a)
            # print("r=", r)
            R += r
            if done or t > 20:
                break
            s = s_
        print("R=", R)
        print("rate=", rate)
        rewards[e] = R
        rates[e] = rate
    torch.save((rewards, rates), data_path)

# train(env=BaseEnv(), n_batch=args.batch_size, mem_cap=args.buffer_memory, prior=args.prior,
#       epoch=args.train_epoch, T=args.train_time_step, mode=args.train_mode, times=args.train_times)

# if not os.path.exists(Model_path):
#     train(env=BaseEnv(), n_batch=args.batch_size, mem_cap=args.buffer_memory, prior=args.prior,
#       epoch=args.train_epoch, T=args.train_time_step, model_path=Model_path)


executer = Base_trainer(n_batch=args.batch_size, mem_cap=args.buffer_memory, prior=args.prior, order=int(args.train_mode),
                        net_path="Outputs/model_" + args.train_mode + ".pth")
# test(env=BaseEnv(), epoch=args.test_epoch, T=args.train_time_step, executer=executer, mode="3")
# test(env=BaseEnv(), epoch=args.test_epoch, T=args.train_time_step, executer=executer, mode="4")
test(env=BaseEnv(), epoch=args.test_epoch, T=args.train_time_step, executer=executer, mode="random")
# # test(env=BaseEnv(), epoch=args.test_epoch, T=args.train_time_step, executer=executer, mode="random")
# random_base = Base_trainer(n_batch=args.batch_size, mem_cap=args.buffer_memory, prior=args.prior, order=int(args.train_mode))
# test(env=BaseEnv(), epoch=args.test_epoch, T=args.train_time_step, executer=random_base, mode="random")



